//---------------------------------------------------------------------------

#include <windows.h>
#include <stdio.h>
#include <conio.h>

//Includes fr PKCS#11
#include "cryptoki.h"

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
void printBytes(CK_BYTE_PTR pBytes, DWORD dLenBytes) {

	for (DWORD d = 0; d < dLenBytes; d++) {
		printf("0x%X ",(pBytes[d]));
	}
}
int main(int argc, char* argv[])
{

   unsigned char ucPWDUser[] = { 0x31, 0x32, 0x33, 0x34, 0x35, 0x36 };
   DWORD dwLenPWDUser = 6;

   CK_FUNCTION_LIST_PTR p11;
   CK_RV returnCode;
   CK_C_GetFunctionList C_GetFunctionListDyn;

   if (argc != 2) {
		printf("Bitte LibName als Argument angeben");
		exit(0);
   }
   //DLL laden
   HINSTANCE hDll = LoadLibrary(argv[1]);
   if (hDll == NULL) {
		printf("Fehler beim Laden der Bibliothek");
		exit(0);
   }

   //Funktionen holen
   C_GetFunctionListDyn = (CK_C_GetFunctionList) GetProcAddress(hDll, "C_GetFunctionList");

   //Liste der Funktionen holen
   returnCode = C_GetFunctionListDyn(&p11);
   if (returnCode != CKR_OK) {
		FreeLibrary(hDll);
		hDll = NULL;
		p11 = NULL;
		printf("\nFehler bei C_GetFunctionList (dyn)");
		exit(0);
   }

   //PKCS#11 initialisieren
   returnCode = p11->C_Initialize(NULL_PTR);
   if (returnCode != CKR_OK) {
		printf("\nFehler bei C_Initialize");
		exit(0);
   } else {
        printf("\nC_Initialize erfolgreich");
   }

   //Anzahl Slots holen
   CK_ULONG ulSlotCount;
   returnCode = p11->C_GetSlotList(CK_TRUE, NULL_PTR, &ulSlotCount);
   if (returnCode != CKR_OK) {
		printf("\nFehler bei C_GetSlotList");
        exit(0);
   } else {
        printf("\nC_GetSlotList erfolgreich");
   }

   //Sind Slots da?
   if (ulSlotCount == 0) {
        printf("\nKeine Slots gefunden");
        exit(0);
   } else {
		printf("\n %d Slots gefunden !",ulSlotCount);
   }

   //Slots holen
   CK_SLOT_ID_PTR pSlotId = (CK_SLOT_ID_PTR) malloc(sizeof(CK_SLOT_ID) * ulSlotCount);
   returnCode = p11->C_GetSlotList(CK_TRUE, pSlotId, &ulSlotCount);
   if (returnCode != CKR_OK) {
        printf("\nFehler bei C_GetSlotList");
        exit(0);
   } else {
        printf("\nC_GetSlotList erfolgreich, verwende SlotID : %X",pSlotId[0]);
   }

   //1. Slot verwenden !!
   //Session ffnen
   CK_SESSION_HANDLE hSession;
   returnCode = p11->C_OpenSession(pSlotId[0], (CKF_RW_SESSION | CKF_SERIAL_SESSION), "Test-InitPin", NULL_PTR, &hSession);
   //War das OK?
   if (returnCode != CKR_OK) {
		printf("\nFehler bei C_OpenSession");
        exit(0);
   } else {
		printf("\nC_OpenSession erfolgreich, Session Handle : %X",hSession);
   }

   //Einloggen ohne PinPad
   returnCode = p11->C_Login(hSession, CKU_USER, ucPWDUser, dwLenPWDUser);
   //War das OK?
   if (returnCode != CKR_OK) {
        printf("\nFehler bei C_Login");
        exit(0);
   } else {
		printf("\nC_Login erfolgreich, User: CKU_USER, PIN: '123456', Session: %X",hSession);
   }

   //////////////////////////////////////
   // Zertifikat suchen
   // Template fr X.509 Zertifikat
   //CK_OBJECT_CLASS cClass   = CKO_CERTIFICATE;
   CK_OBJECT_CLASS cClass   = CKO_DATA;
   CK_CERTIFICATE_TYPE   certType  = CKC_X_509;
   CK_BBOOL cTrue = CK_TRUE;

   //Lotus Notes Test
   unsigned char ucLabel[] = {	0x50, 0x61, 0x73, 0x73, 0x77, 0x6F,
								0x72, 0x64, 0x3a, 0x20, 0x41, 0x67,
								0x42, 0x6e, 0x33, 0x41, 0x6e, 0x34,
								0x69, 0x35, 0x46, 0x6e, 0x4f, 0x31,
								0x30, 0x43
	};

   unsigned char ucApp[] =  {	0x4c, 0x6f, 0x74, 0x75, 0x73, 0x20,
								0x4e, 0x6f, 0x74, 0x65, 0x73, 0x00
	};


   CK_ATTRIBUTE certTempl[]    = {
		{
			CKA_CLASS,
			(unsigned char *) &cClass,
			sizeof(cClass)
		},
		{
			CKA_TOKEN,
			(unsigned char *) &cTrue,
			sizeof(cTrue)
		},
		{
			CKA_PRIVATE,
			(unsigned char *) &cTrue,
			sizeof(cTrue)
		},
		{
			CKA_MODIFIABLE,
			(unsigned char *) &cTrue,
			sizeof(cTrue)
		},
		{
			CKA_LABEL,
			(unsigned char *) &ucLabel,
			26
		},
		{
			CKA_APPLICATION,
			(unsigned char *) &ucApp,
			12
		},
   };

   DWORD dTemp;
   returnCode = p11->C_CreateObject(hSession,certTempl,6,&dTemp);
   if (returnCode != CKR_OK) {
		printf("\nFehler bei C_CreateObject");
		exit(0);
   }

   return 0;
   returnCode = p11->C_FindObjectsInit(hSession,certTempl,2);
   if (returnCode != CKR_OK) {
		printf("\nFehler bei C_FindObjectsInit");
		exit(0);
   } else {
		printf("\nC_FindObjectsInit erfolgreich, CKA_CLASS: CKO_CERTIFICATE, CKA_CERTIFICATE_TYPE: CKC_X_509");
   }
   CK_OBJECT_HANDLE pCertificateHandle[10];
   CK_ULONG ulMaxCount;

   // Erstes gefundene Zertifikat verwenden in pCertificateHandle
   returnCode = p11->C_FindObjects(hSession,pCertificateHandle,10,&ulMaxCount);
   if ( (returnCode != CKR_OK) || (ulMaxCount==0)) {
		printf("\nFehler bei C_FindObjects");
		exit(0);
   } else {
		printf("\nC_FindObjects erfolgreich, CERTIFICATE Handle: %X", pCertificateHandle[0]);
		printf("\n Gefundene Zertifikate : %d",ulMaxCount);
   }

   // Suche abschliessen
   returnCode = p11->C_FindObjectsFinal(hSession);
   if (returnCode != CKR_OK) {
		printf("\nFehler bei C_FindObjectsFinal");
		exit(0);
   } else {
		printf("\nC_FindObjectsFinal erfolgreich");
   }

   // Suche abschliessen
   CK_OBJECT_HANDLE hNewCert;
   DWORD dFormerFound = ulMaxCount;
   returnCode = p11->C_CopyObject(hSession,pCertificateHandle[0],NULL,0,&hNewCert);
   if (returnCode != CKR_OK) {
		printf("\nFehler bei C_CopyObject");
		exit(0);
   } else {
		printf("\C_CopyObject erfolgreich");
		printf("\C_CopyObject erfolgreich, New CERTIFICATE Handle: %X", hNewCert);
   }

   returnCode = p11->C_FindObjectsInit(hSession,certTempl,2);
   if (returnCode != CKR_OK) {
		printf("\nFehler bei C_FindObjectsInit");
		exit(0);
   } else {
		printf("\nC_FindObjectsInit erfolgreich, CKA_CLASS: CKO_CERTIFICATE, CKA_CERTIFICATE_TYPE: CKC_X_509");
   }

   // Erstes gefundene Zertifikat verwenden in pCertificateHandle
   returnCode = p11->C_FindObjects(hSession,pCertificateHandle,10,&ulMaxCount);
   if ( (returnCode != CKR_OK) || (ulMaxCount==0)) {
		printf("\nFehler bei C_FindObjects");
		exit(0);
   } else {
		printf("\nC_FindObjects erfolgreich, CERTIFICATE Handle: %X", pCertificateHandle);
		printf("\n Gefundene Zertifikate       : %d", ulMaxCount);
		printf("\nVorher gefundene Zertifikate : %d", dFormerFound);
   }

   // Suche abschliessen
   returnCode = p11->C_FindObjectsFinal(hSession);
   if (returnCode != CKR_OK) {
		printf("\nFehler bei C_FindObjectsFinal");
		exit(0);
   } else {
		printf("\nC_FindObjectsFinal erfolgreich");
   }

   // Suche abschliessen
   returnCode = p11->C_DestroyObject(hSession,hNewCert);
   if (returnCode != CKR_OK) {
		printf("\nFehler bei C_DestroyObject");
		exit(0);
   } else {
		printf("\C_DestroyObject erfolgreich");
   }

   //Warten
   printf("\nTest erfolgreich !");
   getch();

}
//---------------------------------------------------------------------------
